!
!-----------------------------------------------------------------------
!     Subroutine KT17_BFIELD
!-----------------------------------------------------------------------
!
subroutine kt17_bfield(n,x_a,y_a,z_a,bx_a,by_a,bz_a)

  implicit none
  
  include 'kt17_common.f90'

  integer*4     n,id_a(n),mode,msm,noshield,id,i
  real*8        x_a(n),y_a(n),z_a(n)
  real*8        x,y,z
  real*8        x_mso,y_mso,z_mso
  real*8        bx_mso,by_mso,bz_mso
  real*8        bx_msm,by_msm,bz_msm
  real*8        bx_dcf,by_dcf,bz_dcf
  real*8        bx_dsk,by_dsk,bz_dsk
  real*8        bx_slb,by_slb,bz_slb
  real*8        bx_a(n),by_a(n),bz_a(n)
  real*8        kappa,kappa3
  real*8        fi,gradfix,gradfiy,gradfiz
  real*8        fx,fy,fz,hx,hy,hz

!
! initialize variables
!
  kappa=r0/rss
  kappa3=kappa**3

!
! magnetic field computation
!
  do i=1,n
    x=x_a(i)
    y=y_a(i)
    z=z_a(i)
    
    x=x*kappa
    y=y*kappa
    z=z*kappa
    
    call kt17_mpdist(0,x,y,z,fi,id,gradfix,gradfiy,gradfiz)
    if (fi .lt. mptol) id=1
    if (noshield .eq. 1) id=1

    if (id .eq. 1) then
      bx_dcf=0.0d0
      by_dcf=0.0d0
      bz_dcf=0.0d0
      bx_dsk=0.0d0
      by_dsk=0.0d0
      bz_dsk=0.0d0
      bx_slb=0.0d0
      by_slb=0.0d0
      bz_slb=0.0d0

      fx=0.0d0
      fy=0.0d0
      fz=0.0d0
      hx=0.0d0
      hy=0.0d0
      hz=0.0d0
      call kt17_dipole(x,y,z,fx,fy,fz)
      call kt17_shield(n_dipshld,r_dipshld,x,y,z,hx,hy,hz)
      bx_dcf=kappa3*(fx+hx)
      by_dcf=kappa3*(fy+hy)
      bz_dcf=kappa3*(fz+hz)     

      fx=0.0d0
      fy=0.0d0
      fz=0.0d0
      hx=0.0d0
      hy=0.0d0
      hz=0.0d0
      call kt17_taildisk(x,y,z,fx,fy,fz)
      call kt17_shield(n_diskshld,r_diskshld,x,y,z,hx,hy,hz)
      bx_dsk=tamp1*(fx+hx)
      by_dsk=tamp1*(fy+hy)
      bz_dsk=tamp1*(fz+hz)

      fx=0.0d0
      fy=0.0d0
      fz=0.0d0
      hx=0.0d0
      hy=0.0d0
      hz=0.0d0
      call kt17_tailslab(x,y,z,fx,fy,fz)
      call kt17_shield(n_slabshld,r_slabshld,x,y,z,hx,hy,hz)
      bx_slb=tamp2*(fx+hx)
      by_slb=tamp2*(fy+hy)
      bz_slb=tamp2*(fz+hz)

      bx_msm=bx_dcf+bx_dsk+bx_slb
      by_msm=by_dcf+by_dsk+by_slb
      bz_msm=bz_dcf+bz_dsk+bz_slb

      bx_a(i)=bx_msm
      by_a(i)=by_msm
      bz_a(i)=bz_msm
    else
      bx_a(i)=1.0d-8
      by_a(i)=1.0d-8
      bz_a(i)=1.0d-8
    endif
  enddo

  return
end
