!
!-----------------------------------------------------------------------
!     Subroutine KT17_SHIELD
!-----------------------------------------------------------------------
!
subroutine kt17_shield(n,r,x,y,z,bx,by,bz)

  implicit none
  
  integer*4   jmax,kmax,j,k,n,o
  real*8      r(n),x,y,z
  real*8      c(n),p(n),cypj,sypj,szpk,czpk,sqpp,epp
  real*8      hx,hy,hz
  real*8      bx,by,bz

  o=nint(-0.5+sqrt(n+0.25))
  c(1:o*o)=r(1:o*o)
  p(1:o)=r(o*o+1:o*o+o)
  
  jmax=o
  kmax=o
  
  bx=0.0d0
  by=0.0d0
  bz=0.0d0
  do j=1,jmax
    do k=1,kmax
      cypj=cos(y*p(j))
      sypj=sin(y*p(j))
      szpk=sin(z*p(k))
      czpk=cos(z*p(k))
      sqpp=sqrt(p(j)**2+p(k)**2)
      epp=exp(x*sqpp)
      
      hx=-sqpp*epp*cypj*szpk
      hy=+epp*sypj*szpk*p(j)
      hz=-epp*cypj*czpk*p(k)

      bx=bx+hx*c((j-1)*kmax+k)
      by=by+hy*c((j-1)*kmax+k)
      bz=bz+hz*c((j-1)*kmax+k)
    enddo
  enddo

  return
end
