pro kt17_demo

; this demo also requires the IDL Geopack DLM

; define variables
  r0=0.8
  z01=0.0
  z02=-0.196

; initialize kt17 model
  kt17_reset
  kt17_setpar,0.39,50.0

; create window
  device,decomposed=0
  loadct,39
  xrange=[2,-10]
  yrange=[-4,4]
  p=plot(xrange,yrange,xrange=xrange,yrange=yrange,/nodata,aspect_ratio=1,xthick=2,ythick=2,$
    xtitle='X!DMSM!N [R!DM!N]',ytitle='Z!DMSM!N [R!DM!N]',font_size=16,dimensions=[800,600])

; trace and plot field lines
  for i=0,85,5 do begin
    geopack_sphcar,r0,i,0,x,y,z,/degree,/to_rect  
    kt17_trace,x,y,z,1,xf,yf,zf,fline=fline,r0=r0,/msm,/quiet
    idx=where(sqrt(fline[*,0]^2+fline[*,2]^2) ge r0,cnt)
    if (cnt gt 0) then p=plot(fline[idx,0],fline[idx,2],/overplot,thick=2)

    geopack_sphcar,r0,i,180,x,y,z,/degree,/to_rect
    kt17_trace,x,y,z,1,xf,yf,zf,fline=fline,r0=r0,/msm,/quiet
    idx=where(sqrt(fline[*,0]^2+fline[*,2]^2) ge r0,cnt)
    if (cnt gt 0) then p=plot(fline[idx,0],fline[idx,2],/overplot,thick=2)
  endfor

  for i=95,180,5 do begin
    geopack_sphcar,r0,i,0,x,y,z,/degree,/to_rect
    kt17_trace,x,y,z,-1,xf,yf,zf,fline=fline,r0=r0,/msm,/quiet
    idx=where(sqrt(fline[*,0]^2+fline[*,2]^2) ge r0,cnt)
    if (cnt gt 0) then p=plot(fline[idx,0],fline[idx,2],/overplot,thick=2)

    geopack_sphcar,r0,i,180,x,y,z,/degree,/to_rect
    kt17_trace,x,y,z,-1,xf,yf,zf,fline=fline,r0=r0,/msm,/quiet
    idx=where(sqrt(fline[*,0]^2+fline[*,2]^2) ge r0,cnt)
    if (cnt gt 0) then p=plot(fline[idx,0],fline[idx,2],/overplot,thick=2)
  endfor

; plot planet  
  a=findgen(181)*!dtor    ; dayside
  c=sin(a)
  s=cos(a)+z02
  p=polygon(c,s,/data,color='orange',fill_color='orange')
  
  c=-sin(a)               ; nightside
  s=cos(a)+z02
  p=polygon(c,s,/data,color='black',fill_color='black')

return
end
